#　セーブデータ
	require 'json'
	require 'pathname'
	require 'ciphersaber'
	
	
	path = Pathname.new("./savedata/")
	Dir.mkdir(path) unless path.exist? 
	
	module DarkHall
	
		
		
		FQ_QUIT = 0
		FQ_BIG_CHANGE = 1
		FQ_CHANGE = 2
		FQ_SMALL_CHANGE = 3
		FQ_MINIMUM = 0
		FQ_MAXIMUM = 3
		
		
		module_function
		
		
		
		class SaveData
			attr_reader :path, :keys
			
			
			def SaveData.create_db(keys)
				db = {}
				keys.each do |key|
					eval "db[key] = $#{key}"
				end
				
				return db
			end
			
			
			def initialize(path, *keys)
				@path = Pathname.new(path)
				@keys = keys.map!{|x| x.to_s}
			end
			
			def exist_file?
				return @path.exist?
			end
			
			
			
			
			
			
			def load
				unless self.exist_file? then
					LOGGER.info "セーブデータ #{@path} は存在しませんでした"
					return false
				end
				
				crypted = nil
				open(@path, 'rb'){|file|
					crypted = file.read
				}
				json = decrypt(crypted)
				db = JSON.parse(json)
				
				@keys.each do |key|
					if db.has_key?(key) then
						eval "$#{key} = db[key]"
					else
						eval "$#{key} = nil"
						LOGGER.warn "#{@path} はキー #{key} を持っていません"
					end
				end
			end

			def save
				db = SaveData.create_db(@keys)
				json = nil
				crypted = nil
				

				timelog("JsonDump"){
					#yaml = YAML.dump(db)
					json = db.to_json
				}
				timelog("Encrypt"){
					crypted = encrypt(json)
				}
				
				timelog("Backup"){
					# バックアップを取る
					FileUtils.cp(@path.to_s, @path.to_s + '.bak') if @path.exist?
				}
				
				timelog("Write"){
					open(@path, 'wb'){|file|
						file.write(crypted)
					}
				}
				
				
				if Config::DEBUG then
					timelog("DebugWrite"){
						open(@path.to_s + '.json', 'w'){|file|
							file.write(JSON.pretty_unparse(db))
						}
					}
				end
				
			end
			

		end

		
		
		module_function
		def save_data(store, required_frequency, scene_title)
			# セーブ頻度チェック
			return if SAVE_FREQUENCY_LEVEL < required_frequency
	
			# データセーブ
			LOGGER.info "セーブデータ #{store.path} 書き込み成功 (#{required_frequency}:#{scene_title})"
			store.save
	
		end
		
		def load_data(store)
			store.load
			LOGGER.info "セーブデータ #{store.path} 読み込み成功"
		end
	
		
		
		def save_profile(required_frequency = 1, scene_title = "?")
			save_data($profile_save_data, required_frequency, scene_title)
			save_party_data(required_frequency, scene_title)
			save_members_data(required_frequency, scene_title)
		end
		
		def save_party_data(required_frequency = 1, scene_title = "?")
			temp = $party
			$party = Party.new if $dungeon_parties.find{|x| x.eql?($party)}
			save_data($party_save_data, required_frequency, scene_title)
			$party = temp
		end
		
		def save_members_data(required_frequency = 1, scene_title = "?")
			save_data($members_save_data, required_frequency, scene_title)
		end
		
		def load_profile(symbol)
		
			$profile_save_data = SaveData.new("savedata/#{symbol}_profile.dat", 'week', 'room_troops', 'found_area', 'switch', 'game_config')
			$party_save_data = SaveData.new("savedata/#{symbol}_party.dat", 'party', 'dungeon_parties', 'bar_member_ids', 'reviving_member_ids', 'revived_member_ids')
			$members_save_data = SaveData.new("savedata/#{symbol}_members.dat", 'members')

			load_data($profile_save_data)
			load_data($party_save_data)
			load_data($members_save_data)

			
			$members.compact.each{|x| x.on_load}
			
		end
		
		
		class StorableObject
			def to_json(*a)
				return self.dump.to_json(*a)
			end
			
			
			def dump
				return {:json_class => self.class.name}
			end
		end
	end
	
	
	
	
	
	
