# データ

module DarkHall


	class EnemyModel < Model
		attr_accessor :name, :black_name, :hp_max, :exp, :gold
		attr_accessor :str, :tec, :agl, :vit, :int, :wil, :psy, :cha
		attr_accessor :weapon, :defense, :shield, :is_ghost_body
		attr_accessor :ai_type, :graphic_symbol, :damage_resists, :state_resists
		
		def init_params
			super
			@damage_resists = Hash.new(RES_NORMAL)
			@state_resists = Hash.new(RES_NORMAL)
			@shield = nil
			@is_ghost_body = false

		end
		
		alias ghost_body? is_ghost_body
		
		
	end
	
	ENEMY_DATA = {}
	
	ENEMY_DATA[:KoboltTarget] = EnemyModel.new({
		:name => "不死コボルト",
		:hp_max => 100000, :exp => 30, :gold => 6,
		:str => 19, :tec => 18, :agl => 21,
		:wil => 14, :psy => 13,
		:weapon => Weapon.new(:ENail1), :defense => 4,
		:damage_resists => {DT_COLD => RES_WEAK, DT_HEAT => RES_WEAK, DT_ERECTRIC => RES_WEAK},
		:ai_type => :static, :graphic_symbol => :Kobolt,
	})

	ENEMY_DATA[:Kobolt] = EnemyModel.new({
		:name => "コボルト",
		:hp_max => 18, :exp => 5*6, :gold => 6,
		:str => 19, :tec => 18, :agl => 21,
		:wil => 14, :psy => 13,
		:weapon => Weapon.new(:ENail1), :defense => 4,
		:damage_resists => {DT_COLD => RES_WEAK, DT_HEAT => RES_WEAK},
		:ai_type => :beast, :graphic_symbol => :Kobolt,
	})
	
	
	ENEMY_DATA[:Slime] = EnemyModel.new({
		:name => "スライム",
		:hp_max => 23, :exp => 4*6, :gold => 3,
		:str => 17, :tec => 14, :agl => 19,
		:wil => 12, :psy => 10,
		:weapon => Weapon.new(:ESlimeBody), :defense => 8,
		:damage_resists => {DT_BLOW => RES_PERFECT, DT_HEAT => RES_VERY_WEAK},
		:ai_type => :slime, :graphic_symbol => :Slime,
	})
	
	
	ENEMY_DATA[:Spirit] = EnemyModel.new({
		:name => "スピリット",

		:hp_max => 7, :exp => 7*6, :gold => 0,
		:str => 11, :tec => 16, :agl => 15,
		:wil => 26, :psy => 28,
		:weapon => nil, :defense => 1,
		:damage_resists => {DT_SLASH => RES_STRONG, DT_THRUST => RES_STRONG, DT_BLOW => RES_STRONG, DT_HEAT => RES_PERFECT},
		:ai_type => :spirit, :graphic_symbol => :Spirit, :is_ghost_body => true
	})
	
	ENEMY_DATA[:Rizardman] = EnemyModel.new({
		:name => "リザードマン",

		:hp_max => 25, :exp => 15*6, :gold => 12,
		:str => 22, :tec => 23, :agl => 23,
		:wil => 17, :psy => 14,
		:weapon => Weapon.new(:LongSword), :defense => 6, :shield => Accessory.new(:NoviceGuard),
		:damage_resists => {DT_COLD => RES_VERY_WEAK},
		:ai_type => :beast, :graphic_symbol => :Rizardman
	})

	
	
	ENEMY_DATA[:LostArmor] = EnemyModel.new({
		:name => "ロストアーマー",

		:hp_max => 160, :exp => 150*6, :gold => 120,
		:str => 25, :tec => 22, :agl => 19,
		:wil => 22, :psy => 20,
		:weapon => Weapon.new(:HandAxe), :defense => 13, :shield => Accessory.new(:LargeShield),
		:damage_resists => {DT_ERECTRIC => RES_VERY_WEAK},
		:ai_type => :lost_armor, :graphic_symbol => :LostArmor
	})

	ENEMY_DATA[:LostArmor2] = EnemyModel.new({
		:name => "ロストアーマー+1",

		:hp_max => 200, :exp => 150*6, :gold => 100,
		:str => 28, :tec => 27, :agl => 25,
		:wil => 26, :psy => 24,
		:weapon => Weapon.new(:HandAxe), :defense => 12, :shield => Accessory.new(:LargeShield),
		:damage_resists => {DT_ERECTRIC => RES_WEAK},
		:ai_type => :lost_armor2, :graphic_symbol => :LostArmor
	})

	
	
end
