# 武器
module DarkHall
	# 武器を持ち換える
	# アクセサリーを変更する
	# 武器を拾う
	#
	# ダガー
	# ボーイーナイフ
	# ショートソード
	# ロングソード
	# バスタードソード
	# ツーハンドソード
	# 黒曜石の剣
	# グレートソード
	# クレイモア
	# ロングスピア
	# ランス
	# ハルバード
	# 手斧
	# 戦斧
	# ブーメラン
	# 手裏剣
	# チャクラム
	# 矢
	# ボルト
	# セスタス
	# バックラー
	# 盾
	#
	# 致傷力    材質の鋭さ×武器系統補正
	# 重量      材質の重量×武器系統補正
	# ディレイ  武器系統基本値×柔軟性補正
	#
	# 鋭さ/重量/柔軟性
	# 鉄 (Iron)
	# 鋼鉄 (Steel)
	# 木 (Wood)
	# 霊木 (Hallowed Wood)
	# 世界樹 (Yugdrasil)
	# 獣革 (Beast Leather)
	# 竜鱗 (Dragon Leather)
	# 黒曜石 (Obsidian)
	# 古代樹 (Ancient Wood)
	# ルビー
	# 神鉄 (Divine Metal)
	# ブルークリスタル (Blue Crystal)
	#
	# 普通の (Standard)
	# 頑丈な (Hard)     
	# 丈夫な (Strong)    
	# 鋭い (Sharp)      ダメージ上昇
	# 精巧な (Sophisticated)
	# 達人の (Master)
	# 粗悪な (Bad)
	# 神秘的な (Mysterious)
	# 豪華な (Gorgeous) 
	# 驚異の (Incredible)
	# 美しい (Beautiful)
	# 良質な (Good) 
	# 魔法使いの (Magical)
	# 聖なる (Holy)
	# 祝福された (Blessed)
	# 邪悪な (Dark)
	# 呪われた (Cursed)
	# 壊れた/破れた (Broken)
	
	# 普通の鋼鉄製ロングソード (Standard Long Sword of Steel)
	# 達人の黒曜石製日本刀 (Master Samurai Sword of Obsidian)
	# 祝福された木製矢 (Blessed Arrow of Wood)
	# 精巧な鋼鉄製
	
	
	class EquipmentModel < ItemModel
		attr_accessor :str_bonus, :tec_bonus, :agl_bonus, :vit_bonus
		attr_accessor :int_bonus, :wil_bonus, :psy_bonus, :cha_bonus
		attr_accessor :hitting_bonus, :avoid_bonus, :damage_resists, :state_resists
		
		def init_params
			super
			@str_bonus = 0
			@tec_bonus = 0
			@agl_bonus = 0
			@vit_bonus = 0
			@int_bonus = 0
			@wil_bonus = 0
			@psy_bonus = 0
			@cha_bonus = 0
			@hitting_bonus = 0
			@avoid_bonus = 0
			
			@damage_resists = {}
			@state_resists = {}
			
		end
		
		def matched_prefix?(prefix)
			return true
		end
		
	
	end
	
	
	
	


	class WeaponModel < EquipmentModel
		attr_accessor :weapon_type, :damage_rate
		attr_accessor :damage_types, :long_range, :double_handed
		attr_accessor :attack_number, :attack_parameters
		attr_reader :attack_messages, :ranpage_messages
		attr_reader :smash_messages
		
		def init_params
			super
			@attack_parameters = []
			set_message



		end
		
		def set_message
			@attack_messages = [
			]
			@ranpage_messages = [
			]
			
			@smash_messages = [
			]

		end
		
		def get_attack_message
			@attack_messages[rand(@attack_messages.size)]
		end
		
		def get_ranpage_message
			@ranpage_messages[rand(@ranpage_messages.size)]
		end
		
		def get_smash_message
			@smash_messages[rand(@smash_messages.size)]
		end
		
	end
	
	

	
	module MagicWeapon
		attr_accessor :magic_power_rate, :magic_control_rate
	end
	
	
	
	
	class FistModel < WeaponModel
	
		def init_params
			super
			@long_range = false
			@double_handed = true
			@damage_types = [DT_BLOW]
			@attack_parameters = [:str]
			@attack_number = 6


		end
		
	end


	

	
	
	
	class KnifeModel < WeaponModel
	
		def init_params
			super
			@black_name = "？短剣"
			@long_range = false
			@double_handed = true
			@damage_types = [DT_SLASH, DT_THRUST]
			@attack_number = 7
			@attack_parameters = [:str, :tec]
		end
		
		def matched_prefix?(prefix)
			case prefix
			when :Hard, :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter, Explorer
				return true
			else
				return false
			end
		end

	end
	
	class SwordModel < WeaponModel
	
	
		def init_params
			super
			@black_name = "？剣"
			@long_range = false
			@double_handed = false
			@damage_types = [DT_SLASH]
			@attack_number = 3
			@avoid_bonus = +2
			@extra_captions[0] = "回避+2"
			@attack_parameters = [:str]
		end
		def matched_prefix?(prefix)
			case prefix
			when :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter
				return true
			else
				return false
			end
		end

	end
	
	class AxeModel < WeaponModel
	
	
		def init_params
			super
			@black_name = "？斧"
			@long_range = false
			@double_handed = false
			@damage_types = [DT_SLASH, DT_BLOW]
			@attack_number = 2
			@attack_parameters = [:str]
		end
		def matched_prefix?(prefix)
			case prefix
			when :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter
				return true
			else
				return false
			end
		end

	end

	
	class LargeSwordModel < WeaponModel
	
	
		def init_params
			super
			@black_name = "？大剣"
			@long_range = false
			@double_handed = true
			@attack_parameters = [:str]
			@damage_types = [DT_SLASH, DT_BLOW]
			@attack_number = 2
	
	
		end
		def matched_prefix?(prefix)
			case prefix
			when :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when HeavyFighter
				return true
			else
				return false
			end
		end

	end
	
	
	class SpearModel < WeaponModel
	
	
		def init_params
			super
			@black_name = "？槍"
			@long_range = false
			@double_handed = false
			@attack_parameters = [:str]
			@damage_types = [DT_THRUST]
			@attack_number = 2
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter
				return true
			else
				return false
			end
		end

		
	end
	
	class LargeSpearModel < WeaponModel
	
		def init_params
			super
			@black_name = "？騎兵槍"
			@long_range = false
			@double_handed = true
			@attack_parameters = [:str]
			@damage_types = [DT_THRUST, DT_BLOW]
			@attack_number = 1
			@avoid_bonus = -2
			@extra_captions[0] = "回避-2"

		end
		def matched_prefix?(prefix)
			case prefix
			when :Sharp, :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when HeavyFighter
				return true
			else
				return false
			end
		end

	end

	class ClubModel < WeaponModel
	
		def init_params
			super
			@black_name = "？棒"
			@long_range = false
			@double_handed = false
			@damage_types = [DT_BLOW]
			@attack_parameters = [:str]
			@attack_number = 3

		end
		def matched_prefix?(prefix)
			case prefix
			when :Sharp, :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter, Explorer, Magician, Academian
				return true
			else
				return false
			end
		end

	end

	
	class BowModel < WeaponModel
	
	
		def init_params
			super
			@black_name = "？弓"
			@long_range = true
			@double_handed = true
			@attack_parameters = [:str, :wil]
			@damage_types = [DT_THRUST]
			@attack_number = 1

		end

		def matched_prefix?(prefix)
			case prefix
			when :Sharp, :Hard
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Archer
				return true
			else
				return false
			end
		end

	end
	
	class AutoBowModel < WeaponModel

	
		def init_params
			super
			@black_name = "？自動弓"
			@long_range = true
			@double_handed = false
			@attack_parameters = [:tec]
			@damage_types = [DT_THRUST]
			@attack_number = 1
		end
		def matched_prefix?(prefix)
			case prefix
			when :Sharp, :Hard
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Fighter, HeavyFighter, Magician, Academian, Archer, Explorer
				return true
			else
				return false
			end
		end

	end
	
	class WandModel < WeaponModel
		include MagicWeapon
	
	
		def init_params
			super
			@black_name = "？杖"
			@long_range = false
			@double_handed = false
			@attack_parameters = [:str]
			@damage_types = [DT_BLOW]
			@attack_number = 3
			@damage_rate = 0.5
			@magic_power_rate = 1.0
			@magic_control_rate = 1.0
		end
		def matched_prefix?(prefix)
			case prefix
			when :Sharp, :Hard, :Sophisticated
				return false
			end
			return super
		end
		
		def usable_by?(member)
			case member
			when Magician, Academian
				return true
			else
				return false
			end
		end

	end


	class FistModel
		def set_message
			@attack_messages = [
				"%actorは%targetに殴りかかった！",
				"%actorは%targetめがけて突撃した！",
				"%actorは%targetに飛びかかった！",
			]
			@ranpage_messages = [
				"%actorは%targetに連続攻撃を繰り出した！",
				"%actorは%targetを激しく殴りつけた！",
			]
			
			@smash_messages = [
				"%actorは%targetめがけ、正拳突きを繰り出した！",
				"%actorは全身をしならせ、%targetを蹴りつけた！",
			]

		end
	end

	class KnifeModel
		def set_message
			@attack_messages = [
				"%actorは%targetに斬りかかった！",
				"%actorは短剣を構え、%targetめがけて突撃した！",
			]
			@ranpage_messages = [
				"%actorは%targetに猛然と斬りかかった！",
				"%actorは%targetに近寄り、連撃を繰り出した！",
			]
			@smash_messages = [
				"%actorは剣を両手で握り、渾身の力を込めて%targetに叩きつけた！"
			]
		end
	end

	
	class SwordModel
		def set_message
			@attack_messages = [
				"%actorは%targetに斬りかかった！",
				"%actorは剣を構え、%targetめがけて突撃した！",
				"%actorは%targetを激しく突いた！",
			]
			@ranpage_messages = [
				"%actorは%targetに猛然と斬りかかった！",
				"%actorは%targetに近寄り、連撃を繰り出した！",
			]
			@smash_messages = [
				"%actorは%targetの懐に飛び込み、強烈な一撃を放った！"
			]
		end
	end
	
	class AxeModel
		def set_message
			@attack_messages = [
				"%actorは%targetに斬りかかった！",
				"%actorは斧を振り上げ、%targetめがけて突撃した！",
				"%actorは%targetめがけて斧を振り下ろした！",
			]
			@ranpage_messages = [
				"%actorは%targetに猛然と斬りかかった！",
				"%actorは%targetに近寄り、連撃を繰り出した！",
			]
			@smash_messages = [
				"%actorは斧を両手で握り、渾身の力で%targetに叩きつけた！"
			]
		end
	end
	
	class LargeSwordModel
		def set_message
			@attack_messages = [
				"%actorは%targetに斬りかかった！",
				"%actorは剣を振り上げ、%targetめがけて突撃した！",
				"%actorは%targetめがけて剣を振り下ろした！",
			]
			@ranpage_messages = [
				"%actorは%targetに猛然と斬りかかった！",
			]
			@smash_messages = [
				"%actorは剣を振りかぶり、渾身の力を込めて%targetに叩きつけた！"
			]
		end
	end
	
	class SpearModel
		def set_message
			@attack_messages = [
				"%actorは%targetめがけて突撃した！",
				"%actorは%targetを激しく突いた！",
			]
			@ranpage_messages = [
				"%actorは%targetを猛烈な勢いで突いた！",
			]
			@smash_messages = [
				"%actorは槍を両手で構え、%targetめがけて渾身の一撃を放った！"
			]
		end
	end

	class LargeSpearModel
		def set_message
			@attack_messages = [
				"%actorは%targetめがけて突撃した！",
				"%actorは%targetを激しく突いた！",
			]
			@ranpage_messages = [
				"%actorは%targetめがけ、勢いをつけて連撃を繰り出した！",
			]
			@smash_messages = [
				"%actorは槍に全身の力を込め、%targetめがけて突撃した！"
			]
		end
	end

	class ClubModel
		def set_message
			@attack_messages = [
				"%actorは%targetに殴りかかった！",
				"%actorは%targetめがけて突撃した！",
				"%actorは%targetを激しく打ち据えた！",
			]
			@ranpage_messages = [
				"%actorは%targetに猛然と殴りかかった！",
				"%actorは%targetに近寄り、連撃を繰り出した！",
			]
			@smash_messages = [
				"%actorは棍棒を両手で握り、渾身の力を込めて%targetに叩きつけた！"
			]
		end
	end
	
	class BowModel
		def set_message
			@attack_messages = [
				"%actorは%targetに狙いを定め、矢を撃った！",
			]
		end
	end
	
	class WandModel
		def set_message
			@attack_messages = [
				"%actorは%targetに殴りかかった！",
				"%actorは%targetめがけて突撃した！",
				"%actorは%targetを激しく打ち据えた！",
			]
		end
	end


	
	
	WEAPON_DATA = {}
	WEAPON_DATA[:Hand] = FistModel.new({
		:name => "格闘",
		:damage_rate => 0.4,
	})
	
	WEAPON_DATA[:IronKnife] = KnifeModel.new({
		:price => 40,
		:damage_rate => 0.4,

	})

	WEAPON_DATA[:NoviceSword] = SwordModel.new({
		:price => 10,
		:damage_rate => 0.5,
		:avoid_bonus => 0,
		:extra_captions => [],
	})
	
	WEAPON_DATA[:LongSword] = SwordModel.new({
		:price => 60,
		:damage_rate => 0.7,
	})
	
	
	WEAPON_DATA[:SteelSword] = SwordModel.new({
		:price => 200,
		:damage_rate => 1.0,
	})
	
	
	WEAPON_DATA[:ObsidianSword] = nil
	
	
	
	
	WEAPON_DATA[:Claymore] = LargeSwordModel.new({
		:price => 180,
		:damage_rate => 1.3,
	})
	
	WEAPON_DATA[:SteelClaymore] = nil
	
	WEAPON_DATA[:DragonSlayer] = nil
	
	WEAPON_DATA[:HandAxe] = AxeModel.new({
		:price => 80,
		:damage_rate => 0.9,
	})

	WEAPON_DATA[:NoviceSpear] = SpearModel.new({
		:price => 10,
		:damage_rate => 0.7,
	})


	WEAPON_DATA[:LongSpear] = SpearModel.new({
		:price => 100,
		:damage_rate => 1.0,
	})
	
	WEAPON_DATA[:Lance] = LargeSpearModel.new({
		:price => 250,
		:damage_rate => 2.4,
	})

	WEAPON_DATA[:NoviceClub] = ClubModel.new({
		:price => 10,
		:damage_rate => 0.4,
	})

	WEAPON_DATA[:Mace] = ClubModel.new({
		:price => 60,
		:damage_rate => 0.7,
	})

	
	
	WEAPON_DATA[:NoviceBow] = BowModel.new({
		:price => 10,
		:damage_rate => 1.2,
	})

	
	WEAPON_DATA[:ShortBow] = nil
	
	
	
	WEAPON_DATA[:LongBow] = BowModel.new({
		:price => 120,
		:damage_rate => 1.6,
	})
	
	WEAPON_DATA[:ElderBow] = BowModel.new({
		:price => 300,
		:damage_rate => 2.0,
	})

	
	
	WEAPON_DATA[:ElementalBow] = nil
	
	# 一度に五本の矢を打ち出す魔弓
	WEAPON_DATA[:FairyStinger] = nil
	
	
	WEAPON_DATA[:CrossBow] = nil
	
	


	
	

	
	WEAPON_DATA[:MagicianWand] = WandModel.new({
		:price => 60,
		:magic_power_rate => 1.1,
		:magic_control_rate => 1.3,
	})
	
	WEAPON_DATA[:RubyRod] = WandModel.new({
		:price => 200,
		:magic_power_rate => 1.5,
		:magic_control_rate => 1.3,
	})
	
	WEAPON_DATA[:SapphireRod] = WandModel.new({
		:price => 200,
		:magic_power_rate => 1.3,
		:magic_control_rate => 1.6,
	})


	
	
	
	# 敵の武器
	class NailModel < WeaponModel
	
		def init_params
			super
			@long_range = false
			@double_handed = true
			@damage_types = [DT_SLASH]
			@attack_parameters = [:str]
			@attack_number = 3

			@attack_messages = [
				"%actorは%targetを引っかいた！",
				"%actorは%targetに飛びかかった！",
			]


		end
		
	end
	
	class SlimeBodyModel < WeaponModel
	
		def init_params
			super
			@damage_types = []
			@attack_number = 1
			@attack_parameters = [:str]

			@attack_messages = [
				"%actorは%targetめがけて飛びかかってきた！"
			]


		end
		
	end

	
	WEAPON_DATA[:ENail1] = NailModel.new({
		:damage_rate => 0.7,
	})

	WEAPON_DATA[:ESlimeBody] = SlimeBodyModel.new({
		:damage_rate => 1.1,
	})
	
	
	class ArmorModel < EquipmentModel
		attr_accessor :defense
		
		
		def matched_prefix?(prefix)
			return !([:Sharp, :Sophisticated].include?(prefix))
		end

	end

	class LightArmorModel < ArmorModel
		def init_params
			super
			@black_name = "？軽鎧"
		end
		def usable_by?(member)
			case member
			when Academian, Prayer
				return false
			else
				return true
			end
		end
	end

	class HeavyArmorModel < ArmorModel
		def init_params
			super
			@black_name = "？重鎧"
		end
		def usable_by?(member)
			case member
			when HeavyFighter
				return true
			else
				return false
			end
		end
	end
	
	
	
	class CloakModel < ArmorModel
		def init_params
			super
			@black_name = "？外套"
		end
		def matched_prefix?(prefix)
			return !([:Sharp, :Sophisticated, :Hard].include?(prefix))
		end

	end
	
	ARMOR_DATA = {}
	
	ARMOR_DATA[:NoviceArmor] = LightArmorModel.new({
		:price => 10,
		:defense => 4,
		:avoid_bonus => 0,
	})

	ARMOR_DATA[:LeatherArmor] = LightArmorModel.new({
		:price => 40,
		:defense => 7,
		:avoid_bonus => +1,
	})
	
	ARMOR_DATA[:BreastPreat] = HeavyArmorModel.new({
		:price => 110,
		:defense => 10,
		:avoid_bonus => 0,
	})

	
	ARMOR_DATA[:NoviceCloak] = CloakModel.new({
		:defense => 2,
		:avoid_bonus => +1,
		:price => 10,
	})
	
	ARMOR_DATA[:FeatherCloak] = CloakModel.new({
		:defense => 4,
		:avoid_bonus => +3,
		:price => 50,
	})

	
	
	
	
	
	
	class AccessoryModel < EquipmentModel
		def matched_prefix?(prefix)
			return false
		end
	end
	
	class ArmGuarderModel < AccessoryModel
		def matched_prefix?(prefix)
			return !([:Sharp, :Sophisticated].include?(prefix))
		end
	end
	
	class ShieldModel < AccessoryModel
		attr_accessor :guard_bonus, :extra_defense

		def init_params
			super
			@guard_bonus = 0
			@black_name = "？盾"
		end

		
		def matched_prefix?(prefix)
			return !([:Sharp, :Sophisticated].include?(prefix))
		end
		

	end

	
	class SmallShieldModel < ShieldModel
		def guard_border
			return 60 + @guard_bonus
		end

		def usable_by?(member)
			case member
			when Fighter, Explorer, HeavyFighter, Archer
				return true
			else
				return false
			end
		end
	end
	
	class LargeShieldModel < ShieldModel
		def guard_border
			return 70 + @guard_bonus
		end

		def usable_by?(member)
			case member
			when HeavyFighter, Archer
				return true
			else
				return false
			end
		end
	end

	
	
	
	ACCESSORY_DATA = {}

	ACCESSORY_DATA[:NoviceGuard] = SmallShieldModel.new({
		:price => 10,
		:extra_defense => 5,
	})

	ACCESSORY_DATA[:LeatherBuckler] = SmallShieldModel.new({
		:price => 50,
		:extra_defense => 8,
	})

	ACCESSORY_DATA[:LargeShield] = LargeShieldModel.new({
		:price => 160,
		:extra_defense => 11,
	})

	ACCESSORY_DATA[:Crusader] = LargeShieldModel.new({
		:price => 280,
		:extra_defense => 20,
	})
	
	ACCESSORY_DATA[:ElderGauntlet] = ArmGuarderModel.new({
		:price => 100,
		:avoid_bonus => +2,
	})


	ACCESSORY_DATA[:PurifyingGem] = AccessoryModel.new({
		:price => 120,
		:state_resists => {:PoisonState => RES_PERFECT},
	})

	ACCESSORY_DATA[:ChainMail] = AccessoryModel.new({
		:price => 160,
		:defense => +3,
	})
	

	ACCESSORY_DATA[:LastLeaf] = AccessoryModel.new({
		:price => 200,
	})




	ACCESSORY_DATA[:BlueRibbon] = AccessoryModel.new({
		:price => 100,
		:wil_bonus => +5,
		:psy_bonus => +5,
		:extra_captions => ["集中力+5/霊感+5"],
	})
	
	ACCESSORY_DATA[:Amulet] = AccessoryModel.new({
		:name => "アミュレット",
		:price => 240,
		:description => "魔法攻撃に対する抵抗力を高めるお守り"
		
	})
	
	ACCESSORY_DATA[:Sungrass] = AccessoryModel.new({
		:name => "サングラス",
		:price => 100,
		:damage_resists => {DT_LIGHT => RES_STRONG},
		:state_resist_bonus => {:BlindState => 99},
		:description => "盲目を防ぎ、光耐性を上げる不思議な黒眼鏡"
		
	})

	
	ACCESSORY_DATA[:OperaGlove] = AccessoryModel.new({
		:name => "オペラグローブ",
		:price => 50000,
		:description => "高貴さのにじみ出る赤い手袋。効果は不明"
		
	})

	
	
	
	PRODUCT_SYMBOLS = {}
	PRODUCTS = {}
	DEBUG_PRODUCTS = {}
	PRODUCT_SYMBOLS[PD_WEAPON] = [
		:IronKnife, :NoviceSword, :LongSword, :HandAxe, :NoviceSpear, :LongSpear, :NoviceBow,
		:LongBow, :NoviceClub, :Mace]
	PRODUCTS[PD_WEAPON] = PRODUCT_SYMBOLS[PD_WEAPON].map do |symbol|
		raise "not defined weapon data : #{symbol.to_s}"unless WEAPON_DATA.include?(symbol)
		Weapon.new(symbol)
	end
	PRODUCTS[PD_WEAPON].sort!{|a,b| a.price <=> b.price}
	PRODUCTS[PD_WEAPON] << BundleItem.new(:WoodArrow, 5)
	PRODUCTS[PD_WEAPON] << BundleItem.new(:WoodArrow, 30)
	PRODUCTS[PD_WEAPON] << BundleItem.new(:IronArrow, 5)
	PRODUCTS[PD_WEAPON] << BundleItem.new(:IronArrow, 30)
	PRODUCTS[PD_WEAPON] << Weapon.new(:MagicianWand)
	#PRODUCTS[PD_WEAPON] << BundleItem.new(:Bolt, 5)
	#PRODUCTS[PD_WEAPON] << BundleItem.new(:Bolt, 30)



	PRODUCTS[PD_ARMOR] = []
	PRODUCTS[PD_ARMOR] += [:NoviceArmor, :LeatherArmor, :BreastPreat, :NoviceCloak, :FeatherCloak].map{|x| Armor.new(x)}
	PRODUCTS[PD_ARMOR] += [:NoviceGuard, :LeatherBuckler, :LargeShield, :ElderGauntlet].map{|x| Accessory.new(x)}
	
	
	#PRODUCTS[PD_ACCESSORY]

	
	PRODUCT_SYMBOLS[PD_GOODS] = [:Bandage, :PurifyingWater, :WhiteIncense, :BlackIncense]
	#PRODUCT_SYMBOLS[PD_GOODS] = [:Bandage, :Sage, :RedElixir, :PurifyingWater, :Firework]
	
	PRODUCTS[PD_GOODS] = PRODUCT_SYMBOLS[PD_GOODS].map{|x| Item.new(x)}
	
	PRODUCTS[PD_DEBUG] = []
	PRODUCTS[PD_DEBUG] += [:SteelSword, :Claymore, :ElderBow, :RubyRod, :SapphireRod].map{|x| Weapon.new(x)}
	PRODUCTS[PD_DEBUG] += [:LastLeaf, :PurifyingGem, :ChainMail, :BlueRibbon].map{|x| Accessory.new(x)}
	PRODUCTS[PD_DEBUG] += [:Sage].map{|x| Item.new(x)}
	
	# 言語情報上書き
	WEAPON_DATA.each do |symbol, model|
		next unless model
		model.name = Lang::WeaponName.const_get(symbol) if Lang::WeaponName.const_defined?(symbol)
		model.description = Lang::WeaponDescription.const_get(symbol) if Lang::WeaponDescription.const_defined?(symbol)
	end
	
	ARMOR_DATA.each do |symbol, model|
		next unless model
		model.name = Lang::ArmorName.const_get(symbol) if Lang::ArmorName.const_defined?(symbol)
		model.description = Lang::ArmorDescription.const_get(symbol) if Lang::ArmorDescription.const_defined?(symbol)
	end

	
	ACCESSORY_DATA.each do |symbol, model|
		next unless model
		model.name = Lang::AccessoryName.const_get(symbol) if Lang::AccessoryName.const_defined?(symbol)
		model.description = Lang::AccessoryDescription.const_get(symbol) if Lang::AccessoryDescription.const_defined?(symbol)
	end
	
	PRODUCTS.each_key do |type|
		PRODUCTS[type].each do |product|
			raise "#{product.data_symbol} - data not exist " unless product.data
		end
	end


end
